/**
 * @author libpub
 */
dojo.ready(function() {
	
/*
 * Declare Web Tile Layer Class since it's not yet packaged with the API 
 */
    dojo.declare("esri.layers.WebTileLayer", [esri.layers.TiledMapServiceLayer], {
         constructor: function(urlTemplate, options) {
            var ext = new esri.geometry.Extent({"xmin":-22041259,"ymin":-33265069,"xmax":22041259,"ymax":33265069,"spatialReference":{"wkid":102100}});
			//declare zoom levels for tiles. 18 and 19 aren't available for mapbox, so they're 
			//commented out at the moment
            var lods = [
              {"level" : 0, "resolution" : 156543.033928, "scale" : 591657527.591555}, 
              {"level" : 1, "resolution" : 78271.5169639999, "scale" : 295828763.795777}, 
              {"level" : 2, "resolution" : 39135.7584820001, "scale" : 147914381.897889}, 
              {"level" : 3, "resolution" : 19567.8792409999, "scale" : 73957190.948944}, 
              {"level" : 4, "resolution" : 9783.93962049996, "scale" : 36978595.474472}, 
              {"level" : 5, "resolution" : 4891.96981024998, "scale" : 18489297.737236}, 
              {"level" : 6, "resolution" : 2445.98490512499, "scale" : 9244648.868618}, 
              {"level" : 7, "resolution" : 1222.99245256249, "scale" : 4622324.434309}, 
              {"level" : 8, "resolution" : 611.49622628138, "scale" : 2311162.217155}, 
              {"level" : 9, "resolution" : 305.748113140558, "scale" : 1155581.108577}, 
              {"level" : 10, "resolution" : 152.874056570411, "scale" : 577790.554289}, 
              {"level" : 11, "resolution" : 76.4370282850732, "scale" : 288895.277144}, 
              {"level" : 12, "resolution" : 38.2185141425366, "scale" : 144447.638572}, 
              {"level" : 13, "resolution" : 19.1092570712683, "scale" : 72223.819286}, 
              {"level" : 14, "resolution" : 9.55462853563415, "scale" : 36111.909643}, 
              {"level" : 15, "resolution" : 4.77731426794937, "scale" : 18055.954822}, 
              {"level" : 16, "resolution" : 2.38865713397468, "scale" : 9027.977411}, 
              {"level" : 17, "resolution" : 1.19432856685505, "scale" : 4513.988705} 
             // {"level" : 18, "resolution" : 0.597164283559817, "scale" : 2256.994353}, 
             // {"level" : 19, "resolution" : 0.298582141647617, "scale" : 1128.497176}
            ];
            this.spatialReference = new esri.SpatialReference({ wkid: 102100 });
            this.initialExtent = this.fullExtent = ext;

            this.tileInfo = new esri.layers.TileInfo({
              "rows" : 256, // can also be height
              "cols" : 256, // can also be width
              "origin" : { "x" : -20037508.342787, "y" : 20037508.342787 },
              "spatialReference" : { "wkid" : 102100 },
              "lods" : lods
            });

            this.copyright = options.attribution || "";
            this.urlTemplate = urlTemplate;
            this.tileServers = options.tileServers || [];

            this.loaded = true;
            this.onLoad(this);
          },

          getTileUrl: function(level, row, col) {
            var tileServer = this.tileServers[parseInt(Math.random()*this.tileServers.length)];
             //console.log("tile server is: ", tileServer);
            var tileUrl;
            if ( tileServer ) {
              tileUrl = dojo.string.substitute(this.urlTemplate, [tileServer, level, col, row]);
            } else {
              tileUrl = dojo.string.substitute(this.urlTemplate, [level, col, row]);
            }
             //console.log("tile url: ", tileUrl);
            return tileUrl;
    		}
        });
      });
dojo.require("dojo.string");
dojo.require("esri.map");
dojo.require("esri.layers.FeatureLayer");
dojo.require("esri.dijit.TimeSlider");
dojo.require("dojo.date.locale");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.layout.BorderContainer");
dojo.require("esri.dijit.editing.TemplatePicker");
dojo.require("esri.layers.KMLLayer");
dojo.require("dijit.form.Button");
dojo.require("dijit.layout.AccordionContainer");
//require["esri/map","esri/layers/FeatureLayer","esri/dijit/TimeSlider","dojo/date/locale","dijit/layout/ContentPane","dijit/layout/BorderContainer","esri/dijit/editing/TemplatePicker","esri/layers/KMLLayer","dijit/form/Button","dijit/layout/AccordionContainer"],function(){


var map;
var extDisp;

function init(){
	var startExtent = new esri.geometry.Extent({
		"xmin": -10381241.291084025,
		"ymin": 5616033.311489464,
		"xmax": -10372059.29306128,
		"ymax": 5620877.508157031,
		"spatialReference": {
			"wkid": 102100
		}
	});
	map = new esri.Map("map", {
		extent: startExtent
	});
	
	//Click event for easy extent choosing
		
		dojo.connect(map, "onClick", clicky);
		function clicky(clickEvent){
		//console.log("x is " + clickEvent.mapPoint.x);
		//console.log("y is " + clickEvent.mapPoint.y);
		}
		
		
		var resizeTimer;
		dojo.connect(map, 'onLoad', function(theMap){
			//resize the map when the browser resizes
			dojo.connect(dijit.byId('map'), 'resize', map, map.resize);
		});
		
		/*
 dojo.connect(map, "onLayersAddResult", function(results){
 //build the legend using the template picker
 var symbols = dojo.map(results[0].layer.renderer.infos, function(info){
 return {
 label: info.label,
 symbol: info.symbol
 };
 });
 
 var legend = new esri.dijit.editing.TemplatePicker({
 items: symbols,
 rows: "auto",
 columns: 2,
 style: "border-color:#9CAA9C;"
 }, "templatePickerDiv");
 legend.startup();

});
*/
		//BASEMAP EXAMPLE
		
		var esriBasemap = new esri.layers.ArcGISTiledMapServiceLayer("http://services.arcgisonline.com/ArcGIS/rest/services/Canvas/World_Light_Gray_Base/MapServer");
		var customBasemap = new esri.layers.ArcGISTiledMapServiceLayer("http://lib-geo1.lib.umn.edu:6080/arcgis/rest/services/tests/basemap/MapServer");
		
		
		
		
		//KML EXAMPLE
		
/*		var kmlUrl ='http://dl.dropbox.com/u/8550761/bldgs.kml';
		var kmlUrl = 'http://dl.dropbox.com/u/8550761/mergedFootprints.kml';
		var kml = new esri.layers.KMLLayer(kmlUrl);
		map.addLayer(kml);
*/
		//IMAGE EXAMPLE
		
		//		var imageTestLayer = new esri.layers.ArcGISImageServiceLayer("http://lib-geo1.lib.umn.edu:6080/arcgis/rest/services/tests/una104929_mpls_1910/ImageServer");
		//		map.addLayer(imageTestLayer);


		//WEB TILE LAYER EXAMPLE
		/*
		var abc = ["a", "b", "c"];
		var options = {
			"id": "OpenCycleMap",
			"tileServers": abc,
			"attribution": "<a href=\"http://www.opencyclemap.org/\">Map tiles from OpenCycleMap</a>"
		};
		var url = "http://${0}.tile.opencyclemap.org/cycle/${1}/${2}/${3}.jpg";
		
		
		var mapboxUrl = "http://${0}.tiles.mapbox.com/v3/mapbox.mapbox-streets/${1}/${2}/${3}.png";
		var mapboxOptions = {
			"id": "MapBox",
			"visible": true,
			"tileServers": abc,
			"attribution": "basemap from MapBox!"
		};
		var tileLayer = new esri.layers.WebTileLayer(mapboxUrl, mapboxOptions);
		map.addLayers([tileLayer]);
		
		*/
		//FEATURE LAYER EXAMPLE
				
 		var content = "<b>Year Built: </b>${YEAR_BUILT}<br/><b>Year Destroyed: </b>${YEAR_DESTROYED}";
		var infoTemplate = new esri.InfoTemplate("${NAME}", content);
		featureLayer = new esri.layers.FeatureLayer("http://lib-geo1.lib.umn.edu:6080/arcgis/rest/services/tests/tc_footprint_test/MapServer/0", {
 		mode: esri.layers.FeatureLayer.MODE_SNAPSHOT,
 		outFields: ["*"],
 		infoTemplate: infoTemplate
 		});
 		dojo.connect(map, "onLayersAddResult", initSlider);
 		map.addLayers([customBasemap,esriBasemap,featureLayer]);
		
 
		
		
		map.infoWindow.resize(225, 205);
		
		//flUpdateEndConnectHandle = dojo.connect(hurricaneTracks, "onUpdateEnd", updateSlider);
		
		//display map initally for 1976
		var timeExtent = featureLayer.timeInfo.timeExtent;
		console.log(timeExtent.startTime, timeExtent.endTime);
		
		//hurricaneTracks.setTimeDefinition(timeExtent);
		
		/*
		
		function yearChange(){
			console.log('yearChange triggered');
			//if the slider is currently playing stop and reset it
			if (timeSlider.playing) {
				timeSlider.pause();
			}
			var year = dojo.byId('year').value;
			var timeExtent = new esri.TimeExtent();
			timeExtent.startTime = new Date("1/1/" + year + " UTC");
			timeExtent.endTime = new Date("12/31/" + year + " UTC");
			flUpdateEndConnectHandle = dojo.connect(hurricaneTracks, "onUpdateEnd", updateSlider);
			hurricaneTracks.setTimeDefinition(timeExtent);
		}
		
		function updateSlider(){
			console.log('updateSlider triggered');
			dojo.disconnect(flUpdateEndConnectHandle);
			
			var featureLayer = this; //because this is fired after all features have been updated and we are working with a featureLayer in snapshot mode we can be assured that featureLayer.graphics has all the features that match the layer and time defintion.
			var dateField = featureLayer.timeInfo.startTimeField;
			var minDate = new Date(featureLayer.graphics[0].attributes[dateField]);
			var maxDate = new Date(featureLayer.graphics[0].attributes[dateField]);
			
			dojo.forEach(featureLayer.graphics, function(graphic){
				var currentDate = new Date(graphic.attributes[dateField]);
				if (currentDate.getTime() <= minDate.getTime()) {
					minDate = currentDate;
				}
				
				if (currentDate.getTime() > maxDate.getTime()) {
					maxDate = currentDate;
				}
			});
			
			var currentYearTimeExtent = new esri.TimeExtent();
			currentYearTimeExtent.startTime = minDate;
			currentYearTimeExtent.endTime = maxDate;
			updateTimeString(currentYearTimeExtent);
			
			
			if (dijit.byId('timeSlider')) {
				dijit.byId('timeSlider').destroy();
			}
			var tsDiv = dojo.create("div", null, dojo.byId('timeSliderDiv'));
			
			timeSlider = new esri.dijit.TimeSlider({
				style: "width: 1000px;",
				id: 'timeSlider',
				options: {
					excludeDataAtLeadingThumb: true
				}
			}, tsDiv);
			
			
			var query = new esri.tasks.Query();
			//When the time extent changes update the list to contain unique hurricane's that occurred during
			//the time frame.
			dojo.connect(timeSlider, "onTimeExtentChange", function(timeExtent){
				updateTimeString(timeExtent);
				query.timeExtent = timeExtent;
				featureLayer.queryFeatures(query, function(featureSet){
					var uniqueHurricaneNames = {};
					dojo.forEach(featureSet.features, function(feature){
						var hurricaneName = feature.attributes.NAME;
						uniqueHurricaneNames[hurricaneName] = uniqueHurricaneNames[hurricaneName] + 1 || 1;
					});
					var content = "<br><i>";
					for (hurricane in uniqueHurricaneNames) {
						content = content + hurricane + "<br>";
					}
					dojo.byId("activeHurricanes").innerHTML = content + "</i>";
				});
			});
			
			map.setTimeSlider(timeSlider);
			timeSlider.setThumbCount(2);
			
			timeSlider.createTimeStopsByTimeInterval(currentYearTimeExtent, 1, 'esriTimeUnitsYears', {
				resetStartTime: true
			});
			
			timeSlider.setThumbIndexes([0, 1]);
			timeSlider.setThumbMovingRate(500);
			timeSlider.setLoop(true);
			timeSlider.startup();
			
			var labels = dojo.map(timeSlider.timeStops, function(timeStop){
				return monthNames[timeStop.getUTCMonth()];
			});
			timeSlider.setLabels(labels);
		}
		
		function updateTimeString(timeExtent){
			var startTime = monthNames[timeExtent.startTime.getUTCMonth()] + " " + timeExtent.startTime.getUTCDate();
			var endTime = monthNames[timeExtent.endTime.getUTCMonth()] + " " + timeExtent.endTime.getUTCDate();
			
			dojo.byId("daterange").innerHTML = "View campus layout from <b>" + startTime + "</b> to <b>" + endTime + "</b>";
		}
		
		function startSlider(){
			console.log('startSlider triggered');
			timeSlider.play();
		//console.log("play");
		}
	*/
	
	}
		
		dojo.ready(function(){
		
			require(["dijit/layout/AccordionContainer", "dijit/layout/ContentPane", "dojo/domReady!"], function(AccordionContainer, ContentPane){
				aContainer = new AccordionContainer({
					style: "height: 300px"
				}, "markup");
				//console.dir(aContainer);
				
				aContainer.addChild(new ContentPane({
						
					title: "Twin Cities Campus",
					content: new dijit.form.Button({
						label: "Zoom To",
						onClick: function(){
							var campusExtent = new esri.geometry.Extent({
								"xmin": -10381241.291084025,
								"ymin": 5616033.311489464,
								"xmax": -10372059.29306128,
								"ymax": 5620877.508157031,
								"spatialReference": {
									"wkid": 102100
								}
							});
							map.setExtent(campusExtent);
						}
					}, "TCbuttonNode")
				}));
				aContainer.addChild(new ContentPane({
					title: "Duluth Campus",
					content: new dijit.form.Button({
						label: "Zoom To",
						onClick: function(){
							var campusExtent = new esri.geometry.Extent({
								"xmin": -10251728.493995775,
								"ymin": 5911299.9971265895,
								"xmax": -10246760.087157218,
								"ymax": 5913478.452432757,
								"spatialReference": {
									"wkid": 102100
								}
							});
							map.setExtent(campusExtent);
						}
					}, "DuluthButtonNode")
				}));
				aContainer.addChild(new ContentPane({
					title: "Morris Campus",
					content: new dijit.form.Button({
						label: "Zoom To",
						onClick: function(){
							var campusExtent = new esri.geometry.Extent({
								"xmin": -10676171.176065112,
								"ymin": 5714035.136379502,
								"xmax": -10674699.763270587,
								"ymax": 5715353.675117455,
								"spatialReference": {
									"wkid": 102100
								}
							});
							map.setExtent(campusExtent);
						}
					}, "MorrisButtonNode")
				}));
				aContainer.addChild(new ContentPane({
					title: "Crookston Campus",
					content: new dijit.form.Button({
						label: "Zoom To",
						onClick: function(){
							var campusExtent = new esri.geometry.Extent({
								"xmin": -10754703.056656865,
								"ymin": 6072976.358821927,
								"xmax": -10753728.484546205,
								"ymax": 6074734.410472532,
								"spatialReference": {
									"wkid": 102100
								}
							});
							map.setExtent(campusExtent);
						}
					}, "CrookstonButtonNode")
				}));
				aContainer.startup();
				
			});
			});
			
		
function initSlider(results) {
	console.log("initSlider triggered");
	var timeExtent = new esri.TimeExtent();
	for (i in results) {
		if (results[i].layer.url === "http://lib-geo1.lib.umn.edu:6080/arcgis/rest/services/tests/tc_footprint_test/MapServer/0") {
			timeExtent = results[i].layer.timeInfo.timeExtent;
			}
		}
	
	var timeSlider = new esri.dijit.TimeSlider({
	  style: "width:100%;"
	}, dojo.byId("timeSliderDiv"));
	map.setTimeSlider(timeSlider);
	
	timeSlider.setThumbCount(1);
	timeSlider.setThumbIndexes([0,5]);
	
	timeExtent = timeExtent.offset(4,'esriTimeUnitsYears');
	timeExtent.endTime =new Date();
	timeSlider.createTimeStopsByTimeInterval(timeExtent, 1, 'esriTimeUnitsYears');
	timeSlider.singleThumbAsTimeInstant(true);
			
	  
	timeSlider.setThumbMovingRate(200);
	var labels = dojo.map(timeSlider.timeStops, function(timeStop,i){ 
		if(i%10 === 0){
			return timeStop.getUTCFullYear()}
		else{
			return "";
			}
		
	});      
	
	timeSlider.setLabels(labels);
	var tickCount;
	tickCount = 0;
	for (i in labels) {
		
		if (labels[i] !== "") {
			
			tickCount++;
		} 
	}
	/* 
	 * Can't get the ticks and label to line up properly using the above tick count calculation method. As a work around
	 * I've gone ahead and set the tickCount = 2 below, and finagled the label positioning in mapStyle.css (left:-20% instead of -40%
	 * in order to get the correct year lable at least close to the middle of the year on the slider.
	 */
	
	//console.log(tickCount);
	
	tickCount=2;
		
	timeSlider.setTickCount(tickCount);
	
	timeSlider.startup();

	dojo.connect(timeSlider, "onTimeExtentChange", function(timeExtent) {
	
	  dojo.byId("currentTimeExtent").innerHTML ="<i>" + dojo.string.substitute("${endTime}", timeExtent, function(val) {
	    return dojo.date.locale.format(val, {
	      selector: 'date',
	      datePattern: 'yyyy'
	    	});
		});
		+ "</i>";
	});
	    
  }
	
	

	
dojo.addOnLoad(init);